<template>
  <div class="content page-login">
    <div class="back_step sticky">
      <nuxt-link to="/" class="back">
        <svg-icon name="arrow-left"></svg-icon>
      </nuxt-link>
      <h1 class="title_cate">
        <span>Đăng nhập</span>
      </h1>
    </div>
    <div v-if="pagelogin == true" class="flex tab-default">
      <a class="active" href="javascript:;" @click="typeRegister = false">
        Đăng nhập
      </a>
      <a href="javascript:;" @click="typeRegister = true">
        Tạo tài khoản
      </a>
    </div>
    <div v-else class="flex tab-default">
      <a href="javascript:;" @click="typeRegister = false">Đăng nhập</a>
      <a class="active" href="javascript:;" @click="typeRegister = true">
        Tạo tài khoản
      </a>
    </div>
    <div class="tab-container">
      <div v-if="typeRegister == false" id="dang-nhap" class="width-login">
        <div class="form-default">
          <div class="center">
            <div class="icon bg-blue">
              <img src="/images/graphics/icon-login.png" alt="icon login" />
            </div>
            <p class="color-gray mb30">
              Đăng nhập để theo dõi đơn hàng, lưu danh sách sản phẩm yêu thích
              và nhận ưu đãi hấp dẫn.
            </p>
          </div>
          <div class="form-group mb24">
            <label class="block" for="inputEmail">
              Số điện thoại / Email
            </label>
            <div class="input-wrap">
              <input
                id="inputEmail"
                ref="phone"
                type="email"
                class="form-control"
              />
              <span ref="errPhone" class="error" style="display: none;">
                Thông báo lỗi
              </span>
            </div>
          </div>
          <div class="form-group mb24">
            <label class="block" for="inputEmail">Mật khẩu</label>
            <div class="input-wrap">
              <input ref="password" type="password" class="form-control" />
              <span ref="errPassword" class="error"></span>
            </div>
          </div>
          <div class="form-group flex space-between txt_16 mb24">
            <label class="check-list">
              <span class="text">Tự động đăng nhập lần sau</span>
              <input type="checkbox" checked />
              <span class="checkmark"></span>
            </label>
            <a class="hover-a" href="#">Quên mật khẩu?</a>
          </div>
          <div class="button-bottom flex">
            <a
              class="btn btn-default color-white"
              href="javascript:;"
              @click.prevent="login"
            >
              Tiếp tục
            </a>
          </div>
        </div>
      </div>
      <div v-else id="dang-ky">
        <div class="width-login__2">
          <div class="form-default">
            <div class="center">
              <div class="icon bg-blue">
                <img src="/images/graphics/icon-login.png" alt="icon login" />
              </div>
              <p class="color-gray mb30">
                Tạo tài khoản để theo dõi đơn hàng, lưu danh sách sản phẩm yêu
                thích và nhận ưu đãi hấp dẫn.
              </p>
            </div>
            <div class="form-group mb24">
              <label class="block" for="inputEmail">Họ và tên</label>
              <div class="input-wrap">
                <input
                  ref="name"
                  type="text"
                  class="form-control"
                  placeholder="Họ và tên của bạn"
                />
                <span ref="errName" class="error" style="display: none;">
                  Thông báo lỗi
                </span>
              </div>
            </div>
            <div class="form-group mb24">
              <label class="block" for="inputEmail">Số điện thoại</label>
              <div class="input-wrap">
                <input
                  ref="phone"
                  type="text"
                  class="form-control"
                  placeholder="Số điện thoại của bạn"
                />
                <span ref="errPhone" class="error" style="display: none;">
                  Thông báo lỗi
                </span>
              </div>
            </div>
            <div class="form-group mb24">
              <label class="block" for="inputEmail">Mật khẩu</label>
              <div class="input-wrap">
                <input
                  ref="password"
                  type="password"
                  class="form-control"
                  placeholder="Mật khẩu ít nhất 8 ký tự"
                />
                <span ref="errPassword" class="error" style="display: none;">
                  Thông báo lỗi
                </span>
              </div>
            </div>
            <div class="form-group mb24">
              <label class="block" for="inputEmail">
                Nhập lại mật khẩu
              </label>
              <div class="input-wrap">
                <input
                  ref="re_password"
                  type="password"
                  class="form-control"
                  placeholder="Mật khẩu ít nhất 8 ký tự"
                />
                <span ref="errRePassword" class="error" style="display: none;">
                  Thông báo lỗi
                </span>
              </div>
            </div>
            <div class="button-bottom flex">
              <a
                class="btn btn-default color-white"
                href="javascript:;"
                @click.prevent="register"
              >
                Tạo tài khoản
              </a>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  name: 'LoginPage',
  props: {
    pagelogin: {
      type: Boolean,
      default: true,
    },
  },
  data() {
    return {
      typeRegister: false,
    }
  },
  mounted() {
    document.body.classList.add('page-step')
  },
  destroyed() {
    document.body.classList.remove('page-step')
  },
  methods: {
    async login() {
      const user = {
        phone: this.$refs.phone.value,
        password: this.$refs.password.value,
      }
      try {
        await this.$auth.login({
          data: user,
        })
        this.$refs.phone.value = ''
        this.$refs.password.value = ''
      } catch (e) {
        this.$refs.errPassword.textContent =
          'Mật khẩu không chính xác, nhập lại mật khẩu hoặc đăng nhập bằng số điện thoại / email khác'
        this.$refs.errPassword.style.display = 'block'
      }
    },
    async register() {
      this.$refs.errName.style.display = 'none'
      this.$refs.errPhone.style.display = 'none'
      this.$refs.errPassword.style.display = 'none'
      this.$refs.errRePassword.style.display = 'none'
      const user = {
        name: this.$refs.name.value,
        phone: this.$refs.phone.value,
        registerPassword: this.$refs.password.value,
        retypePassword: this.$refs.re_password.value,
      }
      const { data } = await this.$axios.post('register', user)
      if (data.status !== 0) {
        await this.$auth.login({
          data: {
            phone: user.phone,
            password: user.registerPassword,
          },
        })
        this.$refs.name.value = ''
        this.$refs.phone.value = ''
        this.$refs.password.value = ''
        this.$refs.re_password.value = ''
      } else {
        // eslint-disable-next-line no-prototype-builtins
        if (data.data.hasOwnProperty('name')) {
          this.$refs.errName.textContent = data.data.name[0]
          this.$refs.errName.style.display = 'block'
        }
        // eslint-disable-next-line no-prototype-builtins
        if (data.data.hasOwnProperty('phone')) {
          this.$refs.errPhone.textContent = data.data.phone[0]
          this.$refs.errPhone.style.display = 'block'
        }
        // eslint-disable-next-line no-prototype-builtins
        if (data.data.hasOwnProperty('registerPassword')) {
          this.$refs.errPassword.textContent = data.data.registerPassword[0]
          this.$refs.errPassword.style.display = 'block'
        }
        // eslint-disable-next-line no-prototype-builtins
        if (data.data.hasOwnProperty('retypePassword')) {
          this.$refs.errRePassword.textContent = data.data.retypePassword[0]
          this.$refs.errRePassword.style.display = 'block'
        }
      }
    },
  },
}
</script>
